#include "myutils.h"
#include "alpha.h"

static bool *g_IsChar = g_IsAminoChar;

double GetFractIdGivenPath(const byte *A, const byte *B, const char *Path)
	{
	unsigned PosA = 0;
	unsigned PosB = 0;
	unsigned Ids = 0;
	unsigned Wilds = 0;
	for (const char *p = Path; *p; ++p)
		{
		char c = *p;
		if (c == 'M')
			{
			byte a = toupper(A[PosA]);
			byte b = toupper(B[PosB]);
			if (g_IsChar[a] && g_IsChar[b])
				{
				if (a == b)
					++Ids;
				}
			else
				++Wilds;
			}
		if (c == 'M' || c == 'D')
			++PosA;
		if (c == 'M' || c == 'I')
			++PosB;
		}
	unsigned MinLen = min(PosA, PosB) - Wilds;
	double FractId = (MinLen == 0 ? 0.0 : double(Ids)/double(MinLen));
	return FractId;
	}
